"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getConnectionChecker = void 0;

var _fp = require("date-fns/esm/fp");

var R = _interopRequireWildcard(require("ramda"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var checkConnection = function checkConnection() {
  var connState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var maxAbsence = arguments.length > 1 ? arguments[1] : undefined;
  if (!R.is(Number)(maxAbsence)) return _objectSpread({}, connState, {
    status: undefined
  });
  var _connState$latestTs = connState.latestTs,
      latestTs = _connState$latestTs === void 0 ? 0 : _connState$latestTs;
  var recent = R.compose((0, _fp.isAfter)(new Date()), (0, _fp.addSeconds)(maxAbsence));
  return {
    latestTs: latestTs,
    status: recent(latestTs)
  };
};

var bumpConnection = function bumpConnection() {
  var connState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var time = arguments.length > 1 ? arguments[1] : undefined;
  return _objectSpread({}, connState, {
    latestTs: time
  });
};

var getConnectionChecker = function getConnectionChecker(cb) {
  var state;

  var run = function run(func) {
    return function (value) {
      state = func(state, value);
      if (cb) cb(state.status);
      return state.status;
    };
  };

  return {
    check: run(checkConnection),
    bump: run(bumpConnection)
  };
};

exports.getConnectionChecker = getConnectionChecker;