"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CounterMeter = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _lodash = _interopRequireDefault(require("lodash.round"));

var _lodash2 = _interopRequireDefault(require("lodash.floor"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var styles = function styles() {
  return {
    flexContainer: {
      display: 'flex',
      position: 'relative',
      flexDirection: 'column',
      alignItems: 'center',
      justifyContent: 'center'
    },
    bg: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      zIndex: -1
    },
    box: {
      textAlign: 'center'
    }
  };
};

function textStyleFromText(str, size) {
  var fontSize = Math.max(16, 90 - str.length * 4 - size * 8);
  return {
    fontSize: fontSize
  };
} // function gradientFromValues(value1, value2, offset, dark) {
//   const range = 255 - offset;
//   const base = offset * +!dark;
//   const r1 = base + floor((value1 * 37) % range);
//   const g1 = base + floor((value1 * 77) % range);
//   const b1 = base + floor((value1 * 119) % range);
//   const r2 = base + floor((value2 * 119) % range);
//   const g2 = base + floor((value2 * 37) % range);
//   const b2 = base + floor((value2 * 77) % range);
//   return `linear-gradient(45deg, rgb(${r1}, ${g1}, ${b1}), rgb(${r2}, ${g2}, ${b2}))`;
// }


var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  width: _propTypes["default"].number,
  height: _propTypes["default"].number,
  values: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])),
  config: _propTypes["default"].arrayOf(_propTypes["default"].any),
  // dark: PropTypes.boolean,
  bgOffset: _propTypes["default"].number
};
var defaultProps = {
  width: 300,
  height: undefined,
  values: [],
  config: [],
  // dark: false,
  bgOffset: 230
}; // const contextTypes = {
//   lang: PropTypes.string.isRequired,
// };

var CounterMeterC =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CounterMeterC, _React$Component);

  function CounterMeterC() {
    _classCallCheck(this, CounterMeterC);

    return _possibleConstructorReturn(this, _getPrototypeOf(CounterMeterC).apply(this, arguments));
  }

  _createClass(CounterMeterC, [{
    key: "shouldComponentUpdate",
    // state = {
    //   swap: 0,
    // };
    value: function shouldComponentUpdate(nextProps) {
      var _nextProps$values = nextProps.values,
          values = _nextProps$values === void 0 ? [] : _nextProps$values; // console.log('values in shouldComponentUpdate', values);

      return values.length !== 0 && !values.some(function (v) {
        return typeof v === 'undefined' || Number.isNaN(v);
      });
    } // static getDerivedStateFromProps(nextProps, prevState) {
    //   return { swap: (-Math.sign(prevState.swap - 0.5) + 1) / 2 };
    // }

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          width = _this$props.width,
          height = _this$props.height,
          config = _this$props.config,
          values = _this$props.values,
          bgOffset = _this$props.bgOffset,
          classes = _this$props.classes; // const { swap } = this.state;
      // const second = values.length > 1 ? values[1] : values[0];
      // const lastBg = this.bg;
      // const bg = gradientFromValues(values[0], second, bgOffset);

      return _react["default"].createElement("div", {
        style: {
          width: width,
          height: height
        },
        className: classes.flexContainer
      }, values.map(function (v, i) {
        var value = v;

        var _ref = config[i] || {},
            _ref$unit = _ref.unit,
            unit = _ref$unit === void 0 ? '' : _ref$unit,
            transform = _ref.transform,
            decimals = _ref.decimals,
            toFloor = _ref.floor,
            label = _ref.label;

        if (config[i]) {
          if (transform) {
            if (typeof transform === 'function') try {
              value = config[i].transform(value);
            } catch (err) {
              console.warn('CounterMeter - config[x].transform failed. Value:', value, 'Transform:', transform);
            } else console.warn('CounterMeter - config[x].transform not of type function. transform is:', transform);
          }

          if (typeof decimals === 'number') {
            value = toFloor ? (0, _lodash2["default"])(value, decimals) : (0, _lodash["default"])(value, decimals);
          }

          if (typeof value !== 'string' && typeof value !== 'undefined' && !Number.isNaN(value)) {
            value = value.toLocaleString();
          }
        }

        return _react["default"].createElement("div", {
          key: label || i,
          className: classes.box,
          style: {
            marginBottom: Math.max(10, 30 - values.length * 4)
          }
        }, _react["default"].createElement("span", {
          style: textStyleFromText("".concat(value).concat(unit), values.length)
        }, typeof value === 'undefined' || Number.isNaN(value) && typeof value !== 'string' ? '-' : "".concat(value).concat(unit)), _react["default"].createElement("br", null), _react["default"].createElement(_Typography["default"], null, label || _react["default"].createElement("span", null, "\xA0")));
      }));
    }
  }]);

  return CounterMeterC;
}(_react["default"].Component);

CounterMeterC.propTypes = propTypes;
CounterMeterC.defaultProps = defaultProps;
var CounterMeter = (0, _styles.withStyles)(styles)(CounterMeterC);
exports.CounterMeter = CounterMeter;