"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaticChart = exports.pointsToChartData = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var _styles = require("@material-ui/core/styles");

var R = _interopRequireWildcard(require("ramda"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var pointsToChartData = function pointsToChartData(label) {
  var points = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  /* eslint-disable no-param-reassign */
  if (!points.length) points = [{
    ts: new Date(),
    pl: []
  }];
  /* eslint-enable no-param-reassign */

  var datasets = [];

  var _points = points,
      _points2 = _slicedToArray(_points, 1),
      pl = _points2[0].pl;

  pl.forEach(function (_, ix) {
    datasets.push({
      label: pl.length === 1 ? label : "".concat(label, "-").concat(ix),
      data: R.compose(R.pluck(ix), R.pluck('pl'))(points)
    });
  });
  return {
    labels: R.pluck('ts')(points),
    datasets: datasets
  };
};

exports.pointsToChartData = pointsToChartData;
var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  points: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func]).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  title: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  type: 'line',
  title: 'noname',
  options: {}
};
var pointRadius = 1.5;
var fill = false;
var borderWidth = 1;
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 640
};
var commonOptions = {
  // animation: { duration: 200 },
  legend: {
    labels: {
      boxWidth: 6
    }
  },
  maintainAspectRatio: false
};
var defaultOptions = {
  // bar: {
  //   ...commonOptions,
  // },
  line: _objectSpread({}, commonOptions, {
    // tooltips: { enabled: false },
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          // parser: 'mm:ss',
          tooltipFormat: 'D MMM H:mm:ss.SSS',
          minUnit: 'second',
          displayFormats: {
            millisecond: 'H:mm:ss.SSS',
            second: 'H:mm:ss',
            minute: 'H:mm',
            hour: 'H'
          }
        } // scaleLabel: {
        //   // display: false,
        //   // labelString: 'Date',
        // },

      }],
      yAxes: [// {
        //   scaleLabel: {
        //     // display: false,
        //     // labelString: 'value',
        //   },
        // },
      ]
    }
  })
};

var styles = function styles() {
  return {
    cointainer: {
      position: 'relative',
      margin: 'auto' // width: '100vw',

    }
  };
};

var __StaticChart = function __StaticChart(_ref) {
  var style = _ref.style,
      type = _ref.type,
      title = _ref.title,
      points = _ref.points,
      classes = _ref.classes,
      options = _ref.options,
      rest = _objectWithoutProperties(_ref, ["style", "type", "title", "points", "classes", "options"]);

  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // console.log('Chart init:', type, JSON.stringify(points));
    var data = pointsToChartData(title, points);
    /* eslint-disable no-param-reassign */

    data.datasets.forEach(function (ds, ix) {
      if (!ds.backgroundColor) ds.backgroundColor = chartColors[ix];
      if (!ds.borderColor) ds.borderColor = chartColors[ix];
      if (!ds.pointRadius) ds.pointRadius = pointRadius;
      if (!ds.fill) ds.fill = fill;
      if (!ds.borderWidth) ds.borderWidth = borderWidth;
    });
    /* eslint-enable no-param-reassign */

    chart.current = new _chart["default"](canvasRef.current, {
      type: type,
      data: data,
      options: R.mergeDeepLeft(options, defaultOptions[type])
    });
  }, [points]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, style);

  return _react["default"].createElement("div", {
    className: classes.container
  }, _react["default"].createElement("canvas", _extends({
    ref: canvasRef,
    width: canvasStyle.width,
    height: canvasStyle.height,
    style: canvasStyle
  }, rest)));
};

__StaticChart.propTypes = propTypes;
__StaticChart.defaultProps = defaultProps;
var StaticChart = (0, _styles.withStyles)(styles)(__StaticChart);
exports.StaticChart = StaticChart;